Index: trunk/kernel/syscalls/sys_open.c
===================================================================
--- trunk/kernel/syscalls/sys_open.c	(revision 690)
+++ trunk/kernel/syscalls/sys_open.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_open.c - open a file.
+ * kern/sys_open.c - open a named file
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Author        Alain Greiner (2016,2017,2018,2019)
+ * This file is part of ALMOS-kernel.
  *
- * Copyright (c) UPMC Sorbonne Universites
- *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,19 +17,15 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
 #include <errno.h>
 #include <thread.h>
-#include <printk.h>
 #include <vfs.h>
+#include <sys-vfs.h>
 #include <process.h>
-#include <remote_rwlock.h>
-
-#include <syscalls.h>
+#include <spinlock.h>
+#include <cpu-trace.h>
 
 ///////////////////////////////////
@@ -39,123 +34,47 @@
                uint32_t   mode )
 {
-    vseg_t       * vseg; 
-    error_t        error;
-    xptr_t         file_xp;                 // extended pointer on vfs_file_t
-    uint32_t       file_id;                 // file descriptor index
-    xptr_t         root_inode_xp;           // extended pointer on root inode
+	CPU_HW_TRACE(sys_open);
 
-    char           kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
+	error_t            err;
+	struct vfs_file_s  file;   
+	struct ku_obj      ku_path;
+	thread_t         * this     = current_thread;
+	process_t        * process  = current_process;
+	uint32_t           fd       = (uint32_t)-1;
 
-    thread_t     * this     = CURRENT_THREAD;
-    process_t    * process  = this->process;
+	cpu_trace_write(current_cpu, sys_open);
 
-#if DEBUG_SYS_OPEN || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	if( process_fd_aray_full( process ) )
+	{
+		this->info.errno = ENFILE;
+        CPU_HW_TRACE(sys_open);
+        return fd;
+	}
+   
+	if( VFS_IS( flags , VFS_O_DIRECTORY ) ) VFS_SET( flags , VFS_DIR );
 
-    // check fd_array not full
-    if( process_fd_array_full() )
-    {
+	KU_BUFF( ku_path , pathname );
 
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : file descriptor array full for thread[%x,%x]\n",
-__FUNCTION__ , process->pid , this->trdid );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // check pathname in user space
-    if( vmm_get_vseg( process, (intptr_t)pathname , &vseg ) )
+    // get the cwd lock
+	rwlock_rdlock( &process->cwd_lock );
+   
+	err = vfs_open( &process->vfs_cwd , &ku_path , flags , mode , &file );
+	if( err )
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : user buffer unmapped %x for thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)pathname , process->pid, this->trdid );
-#endif
-		this->errno = EINVAL;
-        return -1;
+		this->info.errno = (err < 0 ) ? -err : err;
+	    rwlock_unlock( &process->cwd_lock );
+	    CPU_HW_TRACE(sys_open);
+	    return fd;
+	}
+	
+	err = process_fd_set( process , &file , &fd );
+	if( err )
+	{
+		vfs_close(&file, NULL);
+		this->info.errno = err;
 	}
 
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : pathname too long for thread[%x,%x]\n",
-__FUNCTION__ , process->pid , this->trdid );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-#if DEBUG_SYS_OPEN
-if( DEBUG_SYS_OPEN < tm_start )
-printk("\n[%s] thread[%x,%x] enter for <%s> / flags %x / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, flags, (uint32_t)tm_start );
-#endif
- 
-    // get cluster and local pointer on reference process
-    xptr_t      owner_xp  = process->owner_xp;
-    process_t * owner_ptr = GET_PTR( owner_xp );
-    cxy_t       owner_cxy = GET_CXY( owner_xp );
-
-    // get extended pointer on root inode in path
-    if( kbuf[0] == '/' )                            // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                            // relative path
-    {
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( owner_cxy , &owner_ptr->cwd_xp ) );
-    }
-
-    // call the relevant VFS function
-    error = vfs_open( root_inode_xp,
-                      kbuf,
-                      owner_xp,
-                      flags,
-                      mode,
-                      &file_xp,
-                      &file_id );
-
-    if( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create file descriptor for %s\n",
-__FUNCTION__ , process->pid , this->trdid , kbuf );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    hal_fence();
-
-#if (DEBUG_SYS_OPEN || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_OPEN
-if( DEBUG_SYS_OPEN < tm_end )
-printk("\n[%s] thread[%x,%x] exit for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_OPEN] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_OPEN] , 1 );
-#endif
-
-    return file_id;
+	rwlock_unlock( &process->cwd_lock );
+	CPU_HW_TRACE(sys_open);
+	return fd;
 }
Index: trunk/kernel/syscalls/sys_opendir.c
===================================================================
--- trunk/kernel/syscalls/sys_opendir.c	(revision 690)
+++ trunk/kernel/syscalls/sys_opendir.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_opendir.c - Open an user accessible VFS directory.
+ * kern/sys_opendir.c - open a directory
  * 
- * Author        Alain Greiner (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,197 +17,51 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
+#include <vfs.h>
+#include <sys-vfs.h>
+#include <process.h>
 #include <thread.h>
-#include <process.h>
-#include <user_dir.h>
-#include <printk.h>
-#include <errno.h>
-#include <vseg.h>
-#include <vfs.h>
-#include <syscalls.h>
-#include <shared_syscalls.h>
+#include <spinlock.h>
 
 ///////////////////////////////////
-int sys_opendir ( char *  pathname,
-                  DIR  ** dirp )
+int sys_opendir ( char * pathname )
 {
-    error_t        error;
-    xptr_t         root_inode_xp;          // extended pointer on path root inode
-    xptr_t         inode_xp;               // extended pointer on directory inode
-    vfs_inode_t  * inode_ptr;              // local pointer on directory inode
-    cxy_t          inode_cxy;              // directory inode cluster
-    uint32_t       inode_type;             // to check directory inode type
-    user_dir_t   * dir_ptr;                // local pointer on user_dir_t
-    vseg_t       * vseg;                   // for user space checking
-    intptr_t       ident;                  // dirent array pointer in user space                  
-    char          kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
-	
-	thread_t     * this    = CURRENT_THREAD;  // client thread
-	process_t    * process = this->process;   // client process
+	error_t             err;
+	struct vfs_file_s   file;
+	struct ku_obj       ku_path;
+	thread_t          * this    = current_thread;
+	process_t         * process = current_process;
+	uint32_t            fd        = (uint32_t)-1;
+	uint32_t            mode      = 0;
+   
+	if( process_fd_array_full( process ) )
+	{
+		this->info.errno = ENFILE;
+	    return fd;
+	}
 
-#if DEBUG_SYS_OPENDIR || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	KU_BUFF(ku_path, pathname);
 
-    // check DIR buffer in user space
-    error = vmm_get_vseg( process , (intptr_t)dirp, &vseg );
+	rwlock_rdlock( &process->cwd_lock );
 
-	if( error )
+	err = vfs_opendir( &process->vfs_cwd , &ku_path , mode , &file );
+	if( err )
 	{
+		this->info.errno = (err < 0 ) ? -err : err;
+	    rwlock_unlock( &process->cwd_lock );
+	    return fd;
+	}
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / DIR buffer %x unmapped / cycle %d\n",
-__FUNCTION__ , process->pid , this->trdid, dirp, (uint32_t)tm_start );
-#endif
-		this->errno = EINVAL;
-		return -1;
-	}	
-
-    // check pathname in user space
-    error = vmm_get_vseg( process , (intptr_t)pathname, &vseg );
-
-	if( error )
+	err = process_fd_set( process , &file , &fd);
+	if( err )
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / pathname %x unmapped / cycle %d\n",
-__FUNCTION__ , process->pid , this->trdid, pathname, (uint32_t)tm_start );
-#endif
-		this->errno = EINVAL;
-		return -1;
-	}	
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s / thread[%x,%x] : pathname too long / cycle %d\n",
- __FUNCTION__ , process->pid , this->trdid, (uint32_t)tm_start );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-#if DEBUG_SYS_OPENDIR
-if( DEBUG_SYS_OPENDIR < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] enter for directory <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_start );
-#endif
-
-    // compute root inode for pathname 
-    if( kbuf[0] == '/' )                        // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                        // relative path
-    {
-        // get cluster and local pointer on reference process
-        xptr_t      ref_xp  = process->ref_xp;
-        process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
-        cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
-    }
-
-    // get extended pointer on directory inode
-    error = vfs_lookup( root_inode_xp,
-                        kbuf,
-                        0,
-                        &inode_xp,
-                        NULL );
-    if( error )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / cannot found directory <%s> / cycle %d\n",
-__FUNCTION__ , process->pid , this->trdid , kbuf , (uint32_t)tm_start );
-#endif
-		this->errno = ENFILE;
-		return -1;
+		vfs_close(&file, NULL);
+		this->info.errno = err;
 	}
    
-    // check inode type 
-    inode_ptr  = GET_PTR( inode_xp );
-    inode_cxy  = GET_CXY( inode_xp );
-    inode_type = hal_remote_l32( XPTR( inode_cxy , &inode_ptr->type ) );
-
-    if( inode_type != FILE_TYPE_DIR )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / <%s> is not a directory / cycle %d\n",
-__FUNCTION__ , process->pid , this->trdid , kbuf , (uint32_t)tm_start );
-#endif
-		this->errno = ENFILE;
-		return -1;
-	}
-   
-    // create an user_dir_t structure in cluster containing directory inode
-    // map it in the reference user process VMM (in a new ANON vseg)
-    // an get the local pointer on the created user_dir_t structure 
-    if( inode_cxy == local_cxy )
-    {
-        dir_ptr = user_dir_create( inode_ptr,
-                                   process->ref_xp );
-    }
-    else
-    {
-        rpc_user_dir_create_client( inode_cxy,
-                                    inode_ptr,
-                                    process->ref_xp,
-                                    &dir_ptr );
-    }
-
-    if( dir_ptr == NULL )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / cannot create user_dir for <%s> / cycle %d\n",
-__FUNCTION__ , process->pid , this->trdid , kbuf , (uint32_t)tm_start );
-#endif
-		this->errno = ENFILE;
-		return -1;
-	}
-   
-    // get ident from user_dir structure
-    ident = (intptr_t)hal_remote_lpt( XPTR( inode_cxy , &dir_ptr->ident ) );
-
-    // set ident value in user buffer
-    hal_copy_to_uspace( dirp,
-                        XPTR( local_cxy , &ident ),
-                        sizeof(intptr_t) );
-
-    hal_fence();
-
-#if (DEBUG_SYS_OPENDIR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_OPENDIR
-if( DEBUG_SYS_OPENDIR < tm_end )
-printk("\n[%s] thread[%x,%x] exit for directory <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_OPENDIR] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_OPENDIR] , 1 );
-#endif
-
-	return 0;
-
-}  // end sys_opendir()
+	rwlock_unlock( &process->cwd_lock );
+	return fd;
+}
Index: trunk/kernel/syscalls/sys_pipe.c
===================================================================
--- trunk/kernel/syscalls/sys_pipe.c	(revision 690)
+++ trunk/kernel/syscalls/sys_pipe.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_pipe.c - open a pipe communication channel
+ * kern/sys_pipe.c - open a pipe communication channel
  * 
- * Author    Alain Greiner  (2016,1017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c)  UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,176 +17,17 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
 #include <vfs.h>
-#include <hal_uspace.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
 #include <thread.h>
-#include <printk.h>
-#include <pipe.h>
+#include <spinlock.h>
 
-#include <syscalls.h>
-
-////////////////////////////
-int sys_pipe ( fdid_t * fd )
+int sys_pipe (uint_t *pipefd)
 {
-    vseg_t       * vseg;
-    pipe_t       * pipe;
-    vfs_file_t   * file_0;
-    vfs_file_t   * file_1;
-    fdid_t         fdid_0;
-    fdid_t         fdid_1;
-    error_t        error;
-
-    thread_t     * this    = CURRENT_THREAD;
-    process_t    * process = this->process;
-
-#if DEBUG_SYS_PIPE || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t   tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_PIPE
-if( DEBUG_SYS_PIPE < tm_end )
-printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, pathname, (uint32_t)tm_end );
-#endif
-
-    // check user buffer is mapped 
-    if( vmm_get_vseg( process , (intptr_t)fd , &vseg ) )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / output user buffer unmapped %x\n",
-__FUNCTION__ , process->pid, this->trdid, (intptr_t)fd );
-#endif
-		this->errno = EINVAL;
-		return -1;
-    }
-
-    // 1. allocate memory in local cluster for pipe descriptor,
-    //    remote buf_descriptor, and associated data buffer
-    pipe = pipe_create( local_cxy,
-                        CONFIG_PIPE_BUF_SIZE );
-
-    if( pipe == NULL )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / no memory for pipe\n",
-__FUNCTION__ , process->pid, this->trdid );
-#endif
-        goto error_1;
-    }
-
-    // 2. allocate memory for fd[0] file descriptor in local cluster
-    // we don't use the vfs_file_create function because there is no inode.
-	file_0 = kmem_alloc( bits_log2(sizeof(vfs_file_t)) , AF_ZERO );
-
-    if( file_0 == NULL ) 
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / no memory for file descriptor\n",
-__FUNCTION__, process->pid, this->trdid );
-#endif
-        goto error_2;
-    }
-    
-    // 3. get fd[0] fdid value and register it in owner process fd_array[]
-    error = process_fd_register( process->owner_xp,
-                                 XPTR( local_cxy , file_0 ),
-                                 &fdid_0 );
-    if ( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / cannot register file descriptor \n",
-__FUNCTION__, process->pid, this->trdid );
-#endif
-        goto error_3;
-    }
-
-    // 4. allocate memory for fd[1] file descriptor in local cluster
-    // we don't use the vfs_file_create function because there is no inode.
-	file_1 = kmem_alloc( bits_log2(sizeof(vfs_file_t)) , AF_ZERO );
-
-    if( file_1 == NULL ) 
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / no memory for file descriptor\n",
-__FUNCTION__, process->pid, this->trdid );
-#endif
-        goto error_4;
-    }
-
-    // 5. get fd[1] fdid value and register it in owner process fd_array[]
-    error = process_fd_register( process->owner_xp,
-                                 XPTR( local_cxy , file_1 ),
-                                 &fdid_1 );
-    if ( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / cannot register file descriptor \n",
-__FUNCTION__, process->pid, this->trdid );
-#endif
-        goto error_5;
-    }
-
-    // link the two file descriptors to the pipe
-    file_0->pipe = pipe;
-    file_1->pipe = pipe;
-
-    // copy fdid_0 & fdid_1 values to user buffer
-    hal_copy_to_uspace( &fd[0] , XPTR( local_cxy , &fdid_0 ) , sizeof(fdid_t) );
-    hal_copy_to_uspace( &fd[1] , XPTR( local_cxy , &fdid_1 ) , sizeof(fdid_t) );
-
-#if (DEBUG_SYS_PIPE || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_PIPE
-if( DEBUG_SYS_PIPE < tm_end )
-printk("\n[%s] thread[%x,%x] exit for <%s> / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pathname, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_PIPE] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_PIPE] , 1 );
-#endif
-
-    return 0;
-
-error_5:    // release memory allocated for fd[1] file descriptor
-
-    kmem_free( file_1 , bits_log2(sizeof(vfs_file_t)) );
-
-error_4:    // release fdid_0 from fd_array[]
-
-    process_fd_remove( process->ref_xp , fdid_0 );
-
-error_3:    // release memory allocated for fd[0] file descriptor
-
-    kmem_free( file_0 , bits_log2(sizeof(vfs_file_t)) );
-
-error_2:    // release memory allocated for the pipe 
-
-    pipe_destroy( XPTR( local_cxy , pipe ) );
-
-error_1:   // set errno and return error
-
-    this->errno = ENOMEM;
-    return -1;
-
-}  // end sys_pipe()
+	current_thread->info.errno = ENOSYS;
+	return -1;
+}
Index: trunk/kernel/syscalls/sys_ps.c
===================================================================
--- trunk/kernel/syscalls/sys_ps.c	(revision 1)
+++ trunk/kernel/syscalls/sys_ps.c	(revision 1)
@@ -0,0 +1,129 @@
+/*
+ * kern/sys_ps.c - show kernel active processes and threads
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012,2013,2014,2015 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <task.h>
+#include <pid.h>
+#include <thread.h>
+#include <vmm.h>
+#include <errno.h>
+#include <utils.h>
+#include <rpc.h>
+#include <cluster.h>
+
+extern error_t ps_func(void *param);
+
+/* TODO: add remote support. */
+static error_t sys_ps_check_thread(pid_t pid, uint_t tid, struct thread_s **th_ptr)
+{
+	struct task_s *task;
+	struct thread_s *thread;
+        cid_t  location;
+
+	if(pid == PID_MIN_LOCAL)
+		return EINVAL;
+
+        location = task_whereis(pid);
+
+        tasks_manager_lock();
+        if ( location == current_cid )
+        {
+                task = task_lookup(pid)->task;
+
+                if((task == NULL) || (tid > task->max_order))
+                        return EINVAL;
+
+                thread = task->th_tbl[tid];
+
+                if((thread == NULL)                 ||
+                   (thread->signature != THREAD_ID) ||
+                   (thread->info.attr.key != tid))
+                {
+                        return ESRCH;
+                }
+
+                *th_ptr = thread;
+                return 0;
+        }
+        else
+        {
+                printk(WARNING, "%s: cluster %u can't execute this function on remote task (pid %u on cluster %u)\n",   \
+                                __FUNCTION__, current_cid, pid, location);
+                return ENOSYS;
+        }
+        tasks_manager_unlock();
+}
+
+/*TODO: use RPC_ARG_NULL instead of sending a useless variable.
+ * It's not urgent, it's a minor change.
+ */
+RPC_DECLARE(__ps_func,                                  \
+                RPC_RET( RPC_RET_PTR(error_t, err) ),   \
+                RPC_ARG( RPC_ARG_PTR(error_t, foo) )    \
+           )
+{
+        *err = ps_func(NULL);
+}
+
+int sys_ps(uint_t cmd, pid_t pid, uint_t tid)
+{
+        cid_t next;
+	error_t err;
+	struct thread_s *thread;
+        struct kernel_iter_s *kernel_iter;
+
+        err = 0;
+
+	switch(cmd)
+	{
+	case TASK_PS_TRACE_OFF:
+		err = sys_ps_check_thread(pid, tid, &thread);
+		if(err) goto fail_trace_off;
+		thread->info.isTraced = false;
+		cpu_wbflush();
+		printk(INFO,"INFO: pid %d, tid %x, tracing is turned [OFF]\n", pid, tid);
+		break;
+
+	case TASK_PS_TRACE_ON:
+		err = sys_ps_check_thread(pid, tid, &thread);
+		if(err) goto fail_trace_on;
+		thread->info.isTraced = true;
+		cpu_wbflush();
+		printk(INFO,"INFO: pid %d, tid %x, tracing is turned [ON]\n", pid, tid);
+		break;
+
+	case TASK_PS_SHOW:
+                kernel_foreach_backward(kernel_iter, next)
+                {
+                        RCPC( next, RPC_PRIO_PS, __ps_func,
+                              RPC_RECV( RPC_RECV_OBJ(err) ),
+                              RPC_SEND( RPC_SEND_OBJ(err) )
+                           );
+                }
+		break;
+	}
+
+fail_trace_on:
+fail_trace_off:
+	current_thread->info.errno = err;
+	return err;
+}
